/* lib/ptsrv.p
 *
 */

define new global shared variable hDataset   as handle    no-undo.	/* ugly hack :( +++ */

define variable serverType as character no-undo.

define variable dcXID    as integer   no-undo.
define variable result   as character no-undo.

define variable fifo_in  as character no-undo.
define variable fifo_out as character no-undo.

define variable qName    as character no-undo.

define variable sendPretty  as logical   no-undo initial false.
define variable sendSchema  as logical   no-undo initial false.			/* false = no 4GL specific stuff like FORMAT	*/
define variable omitInitVal as logical   no-undo initial false.

define variable ok        as logical     no-undo.
define variable i         as integer     no-undo.
define variable trxNum    as integer     no-undo.
define variable cmd       as character   no-undo.
define variable UID       as character   no-undo.
define variable dcList    as character   no-undo.
define variable oldNow    as integer     no-undo.

define variable my_id     as integer     no-undo.

define variable bh_mc     as handle  no-undo.
define variable bh_uio    as handle  no-undo.

define new global shared variable dbgMode  as integer no-undo initial 1.
define new global shared variable rawMode  as integer no-undo initial 5.
define new global shared variable timeMode as integer no-undo initial 2.
define new global shared variable rowLimit as integer no-undo.

define new global shared variable custId       as character no-undo.
define new global shared variable pt_shortname as character no-undo.
define new global shared variable zmonName     as character no-undo.

define new global shared variable x as integer no-undo initial 5.

define stream inStrm.

{ssg/sausage16.i}

define temp-table tt_protop no-undo
  field order    as integer
  field scrType  as character
  field procName as character
  field scrTitle as character
  field dcName   as character
  field ttName   as character
  field minRows  as integer
  field maxRows  as integer
  field ptCmd    as character
  index pt-idx is primary unique order
.

define temp-table tt_client no-undo
  field clientId    as character
  field lastContact as datetime-tz
  field rMode       as integer   initial 5
  field tMode       as integer   initial 2
  field rLimit      as integer
.

define temp-table tt_dataCollector no-undo
  field xId      as integer
  field clientId as character
  field xActive  as logical
  field dcName   as character
  field dcHandle as handle
.

run ssg/sausage04.p persistent.						/* sausage lib						*/

function dcLaunch returns logical ( dcClient as character, dcProg as character, dcEnable as logical ):

  dcXID = dcXID + 1.

  create tt_dataCollector.
  assign
    tt_dataCollector.xId      = dcXID
    tt_dataCollector.clientId = dcClient
    tt_dataCollector.xActive  = dcEnable 
  .

  if not connected( "dictdb" ) then
    do:
      if lookup( substring( dcProg, r-index( dcProg, "/" ) + 1 ), "apsv.p,dbid.p,df.p,netstat.p,osinfo.p,pasoe.p,appmon.p" ) <= 0 then
        do:
          if dbgMode >= 0 then message now dcProg "requires a db connection to launch".
          return yes.
        end.
    end.

  if dbgMode >= 4 then message now "launching data collector:" dcProg.

  do on error undo,  leave
     on stop  undo,  leave
     on endkey undo, leave:

    run value( dcProg ) persistent set tt_dataCollector.dcHandle ( output tt_dataCollector.dcName ).

    if valid-handle( dcHandle ) then run "mon-init" in dcHandle.

    if dbgMode >= 0 then message now dcProg "has been initialized as" tt_dataCollector.dcName.

  end.

  return yes.

end.

function clientLaunch returns logical ( clientId as character ):

  define variable pname as character no-undo.
  define variable dname as character no-undo.

  find tt_client no-lock where tt_client.clientId = clientId no-error.
  if available( tt_client ) then
    do:
      message "Client:" clientId "exists!".
      return false.
    end.
   else
    do:

      /* message "Launching client:" clientId "!".
       */

      create tt_client.
      assign
        tt_client.clientId = clientId
        tt_client.lastContact = now
      .

      if dbgMode >= 0 then message now "Launching data collectors" clientId.

      for each tt_protop where tt_protop.procName <> "":
        dcLaunch( clientId, tt_protop.procName, yes ).
      end.

      message now "all data collectors have been initialized".

      return true.

    end.

end.


procedure initProTopServer:

  define input parameter srvType as character no-undo.				/* "direct", "http" or "stomp"			*/
  define input parameter p1      as character no-undo.				/* server name					*/
  define input parameter p2      as character no-undo.				/* db name					*/

  serverType = srvType.

  if serverType <> "direct" then                                        	/* initialize protop environment                */
    do:
      run lib/protoplib.p persistent.
      run lib/vstlib.p persistent.
      run lib/protop-cfg.p persistent.
    end.

  create dataset hDataset.

  return.

end.


procedure doRequest:

  define input  parameter cmd    as character no-undo.

  define variable dcName  as character no-undo.
  define variable xList   as character no-undo.
  define variable argVal  as character no-undo.
  define variable argList as character no-undo.

  define variable cscCmd  as character no-undo.
  define variable dbaCmd  as character no-undo.

  define variable my_dbAccess as int64 no-undo.
  define variable my_dbRead   as int64 no-undo.

  define variable winPID as integer no-undo.

  define variable i as integer no-undo.

  assign
    UID     = ""
    dcList  = ""
    xList   = ""
    argList = ""
  .

  if ldbname(1) <> ? then
    do:

      ok = bh_uio:find-first( substitute( "where _userio-id = &1", my_id ), no-lock ) no-error.
      if ok = yes then
        assign
          my_dbAccess = bh_uio:buffer-field( "_userio-dbAccess" ):buffer-value() - my_dbAccess
          my_dbRead   = bh_uio:buffer-field( "_userio-dbRead"   ):buffer-value() - my_dbRead
        .

    end.


  assign
    ok = hDataset:set-buffers( "" )
  no-error.

  if num-entries( cmd, "|" ) = 1 then
    xList = cmd.
   else
    assign
      UID    = entry( 1, cmd, "|" )
      xList  = entry( 2, cmd, "|" )
    .

  if xList begins "xcmd=" then
    do:

      find tt_client no-lock where tt_client.clientId = UID.
      assign
        rawMode  = tt_client.rMode
        timeMode = tt_client.tMode
        rowLimit = tt_client.rLimit
      .

      if num-entries( entry( 2, xList, "=" ), "+" ) > 1 then
        argList = entry( 2, entry( 2, xList, "=" ), "+" ).

      if opsys = "unix" then
        do:
          cscCmd = "$DLC/bin/promon  &1 < $PROTOP/etc/promon.csc_&2 > /dev/null 2>&&1".
          dbaCmd = "$DLC/bin/_proutil &1 -C dbanalys -Bp 10 > $PROTOP/dbanalys/&2.dba 2>&&1 &&".
        end.
       else
        do:
          cscCmd = "%DLC%~\bin~\promon  &1 < %PROTOP%~\etc~\promon.csc_&2 > nul 2>&&1".
          dbaCmd = "%DLC%~\bin~\_proutil &1 -C dbanalys -Bp 10 > %PROTOP%~\dbanalys~\&2.dba 2>&&1 &&".
       /* dbaCmd = "%DLC%~\bin~\_proutil &1 -C dbanalys -Bp 10 > %PROTOP%~\dbanalys~\&2.dba 2>&&1".    */
       /* dbaCmd = "%PROTOP%~\bin~\dbanalys.bat &1 %PROTOP%~\dbanalys~\&2.dba". */
       /* dbaCmd = "start /b %DLC%~\bin~\_proutil &1 -C dbanalys -Bp 10 > %PROTOP%~\dbanalys~\&2.dba 2>&&1". */
       /* dbaCmd = "start /b %PROTOP%~\bin~\dbanalys.bat &1 %PROTOP%~\dbanalys~\&2.dba". */
       /* dbaCmd = "%PROTOP%~\bin~\dbanalys.bat &1 %PROTOP%~\dbanalys~\&2.dba". */
        end.

      case entry( 1, entry( 2, xList, "=" ), "+" ):

        /* these impact all client sessions
         */

        when "csc_on"   then os-command silent value( substitute( cscCmd, pdbname( 1 ), "on"  )).
        when "csc_off"  then os-command silent value( substitute( cscCmd, pdbname( 1 ), "off" )).

        when "dba"      then
          do:
            if opsys = "unix" then
              os-command silent value( substitute( dbaCmd, pdbname( 1 ), pt_shortname )).
             else
              os-command silent value( substitute( dbaCmd, pdbname( 1 ), pt_shortname )).
              /* os-command no-wait value( substitute( dbaCmd, pdbname( 1 ), pt_shortname )). */
              /* run spawn ( substitute( dbaCmd, pdbname( 1 ), pt_shortname ), "", output winPID ). */

          end.

        /* these are specific to a client session
         */

        when "raw_Interval"   then rawMode = 5.
        when "raw_Cumulative" then rawMode = 4.
        when "raw_Raw"        then rawMode = 3.

        when "time_Summary"   then timeMode = 1.
        when "time_Rate"      then timeMode = 2.

        when "rowLimit" then rowLimit = integer( entry( 2, entry( 2, xList, "=" ), "+" )).

      end.

      assign
        tt_client.rMode  = rawMode
        tt_client.tMode  = timeMode
        tt_client.rLimit = rowLimit
      .

      return.

    end.
   else
    do:

      /* get a dcList that is only dcNames -- pull any args (specified by ":") out of the command string
       */

      do i = 1 to num-entries( xList ):

        assign
          dcName = entry( i, xList )
          argVal = ""
        .

        if num-entries( dcName, ":" ) > 1 then
          assign
            argVal  = entry( 2, dcName, ":" )
            dcName  = entry( 1, dcName, ":" )
          .

        assign
          argList = argList + ( if dcList > "" then ":" else "" ) + argVal		/* dcList is deliberate...		*/
          dcList  = dcList +  ( if dcList > "" then "," else "" ) + dcName
        .

      end.

      find first tt_dataCollector where tt_dataCollector.clientId = UID no-error.
      if not available( tt_dataCollector ) then clientLaunch( UID ).

      for each tt_dataCollector where tt_dataCollector.clientId = UID:
        tt_dataCollector.xActive = ( dcList = "" or dcList = ? or dcList = "all" ).
      end.

      if num-entries( dcList ) >= 1 and dcList <> "all" then
        for each tt_dataCollector where tt_dataCollector.clientId = UID:
          tt_dataCollector.xActive = ( lookup( tt_dataCollector.dcName, dcList ) > 0 ).
        end.

      for each tt_dataCollector no-lock where tt_dataCollector.clientId = UID and tt_dataCollector.xActive = true:

        /* oldNow = mtime. */
        if num-entries( dcList ) > 0 then
          do:
            argVal = entry( lookup( tt_dataCollector.dcName, dcList ), argList, ":" ).
            if valid-handle( dcHandle ) then run "mon-update" in dcHandle ( argVal ).
          end.

      /*  message tt_dataCollector.dcName ( mtime - oldNow ). */

      end.

    end.

  /* oldNow = mtime. */

  if ldbname(1) <> ? then
    do:

      ok = bh_uio:find-first( substitute( "where _userio-id = &1", my_id ), no-lock ) no-error.
      if ok = yes then
        assign
          my_dbAccess = bh_uio:buffer-field( "_userio-dbAccess" ):buffer-value() - my_dbAccess
          my_dbRead   = bh_uio:buffer-field( "_userio-dbRead"   ):buffer-value() - my_dbRead
        .

    end.

  publish "updPTStats" ( my_id, my_dbAccess, my_dbRead ).

  {ssg/sausage08.i}

  return.

end.


procedure getRequest:

  define output parameter cmd as character no-undo.

  assign
    ok = hDataset:set-buffers( "" )
  no-error.

  cmd = "".

  get_req: do while true
    on error  undo, retry get_req
    on endkey undo, retry get_req:

    if not retry then
      i = 0.
     else	/* maybe we should accumulate incomplete cmd strings? */
      do:
        i = i + 1.
        message now i "retrying get_req: interrupted cmd read".
        if cmd > "" then
          do:
            message now i "cmd interrupted:" cmd.
            leave get_req.
          end.
        if i >= 5 then leave get_req.
      end.

    leave get_req.

  end. /* get_req */

  return.

end.


function add2ds returns logical ( input h as handle ):

  hDataset:add-buffer( h ).

  return true.

end.


function getTempTableHandle returns handle ( input n as character ):

  define variable i as integer no-undo.
  define variable b as handle  no-undo.
  
  do i = 1 to hDataset:num-buffers:
    b = hDataset:get-buffer-handle( i ).
    if b:name = n then return b.
  end.

  return ?.

end.


/*** main body
 ***
 ***/

/* plain old protop users might not have a custid and that's ok
 *
 */

file-info:file-name = "etc/custid.cfg".
if file-info:full-pathname = ? then
  custId = "".
 else
  do on error undo, leave
     on endkey undo, leave:
    input stream inStrm from value( file-info:full-pathname ).
    import stream inStrm unformatted custId.
    input stream inStrm close.
  end.

if ldbname(1) <> ? then
  do:

    create buffer bh_mc  for table "_myconnection".
    create buffer bh_uio for table "_userio".

    ok = bh_mc:find-first( "", no-lock ) no-error.
    my_id = bh_mc:buffer-field( "_myconn-userid" ):buffer-value() + 1.

    delete object bh_mc.

  end.

/*** run lib/jsonlib.p persistent. ***/

run getConfig( "protop.json", output result ).						/* find protop.json (describes data collectors)			*/
if result begins '~{"tt_protop":[' then
  do:

    result = replace( result, "~n", "" ).						/* pretty printed json is too challenging for json2tt		*/
    result = trim( substring( result, index( result, "[" ) + 1 ), "~{~}]" ).		/* and we just want the rows - none of the wrapper		*/

    run json2tt( string( result ), ( buffer tt_protop:handle )).

  end.

session:add-super-procedure( this-procedure ).

return.
